#!/usr/bin/env node

const myProgVersion = require("./package.json").version;
const prog = require("caporal");

const CONSTANTS = require('./CONSTANTS')

/* const superagent = require('superagent')
 var syncrequest = require('sync-request')
 "sync-request": "^6.1.0",
 "superagent": "^5.2.2",
 "thread-sleep": "^2.2.0"
 "fs-extra": "^9.0.0",   
 "caporal": "^1.4.0",  moved to github:prakis/caporal
*/

//const actions = require('./actions');  actions.download(args);
const { Upload, Download, CreateGroup, JoinGroup } = require("./model/actions");
const { DeleteFile } = require("./model/delete");

// ----------- upload ---------------
prog.version(myProgVersion)
    // you specify arguments using .argument()
    // 'app' is required, 'env' is optional
    .command("upload", "Upload a file") //.alias("u")
    .argument("<"+CONSTANTS.CLI_KEY_FILE_NAME+">", "File name to upload") 
    .option(
        "--public",
        "Upload file to public directory (anyone with link can download it)"
    )
    .action(function (args, options, logger) {
        // args = {"file-name": "abc.txt"}        // options = {"tail" : 100}
        let up = new Upload(args, options);
        up.action();
    });
// ----------- download ----------
prog.version(myProgVersion)
    .command("download", "Download a file") //.alias("d")
    .argument("<"+CONSTANTS.CLI_USER_ENTERED_FILE_NUMBER+">", "File number to download", prog.INT) 
    .action(function (args, options, logger) {
        // args = {"elenumber": "321"}
        let downlo = new Download(args);
        downlo.action();
    });    
// ----------- join-group ----------
prog.version(myProgVersion)
    .command("join", "Join a group").alias("join-group")
    .argument("<"+CONSTANTS.CLI_JOIN_GROUP_CONFIG_FILE+">", "Group information config file") 
    .action(function (args, options, logger) {
        let jg = new JoinGroup(args);
        jg.action();
    });  
// ----------- create-group ----------
prog.version(myProgVersion)
    .command("create-group", "Create a group") 
    //.argument("<"+CONSTANTS.CLI_GROUP_CONFIG_FILE+">", "Group config file") 
    //.argument("<newGroupName>", "Your new Group name")  
    .option(
        "--credentials <credentialsFile>",
        "credentials file (not the aws credentials file)"
    )   
    .action(function (args, options, logger) {
        let cg = new CreateGroup(args, options);
        cg.action();
    });  
// ----------- delete ----------
prog.version(myProgVersion)
    .command("delete", "Delete a file") //.alias("d")
    .argument("<"+ CONSTANTS.CLI_USER_ENTERED_FILE_NUMBER + ">", "File number to delete", prog.INT) 
    .action(function (args, options, logger) {
        let de = new DeleteFile(args, options);
        de.action();
    });  



    /*prog.version("1.0.0")
    // you specify arguments using .argument()
    // 'app' is required, 'env' is optional
    .command("deploy", "Deploy an application")
    .argument("<app>", "App to deploy", /^myapp|their-app$/)
    .argument(
        "[env]",
        "Environment to deploy on",
        /^dev|staging|production$/,
        "local"
    )
    // you specify options using .option()
    // if --tail is passed, its value is required
    .option(
        "--tail <lines>",
        "Tail <lines> lines of logs after deploy",
        prog.INT
    )
    .action(function (args, options, logger) {
        // args and options are objects
        // args = {"app": "myapp", "env": "production"}
        // options = {"tail" : 100}
    });*/

prog.name("ele").parse(process.argv);
//prog.parse(process.argv);

// ./myprog deploy myapp production --tail 100