const utils = require('../utils/utils')
const CONSTANTS = require('../CONSTANTS')
const { BUCKET_NAME, GROUP_NAME, GROUP_ID, FILE_INDEX_FROM_SERVER, HTTPS, DEBUG, CLI_GROUP_CONFIG_FILE,
    PUBLIC_SHARED_FOLDER, S3_SERVER_ENDPOINT, CLI_USER_ENTERED_FILE_NUMBER, CLI_KEY_FILE_NAME } = require('../CONSTANTS')
const s3utils = require('../utils/s3utils')
const { BaseCommand } = require("./basecommand")

const axios = require('axios')
const ini = require('ini')
const chalk = require('chalk')
const fs = require('fs')

const AWS_Amazon_Storage_Bucket = "s3.amazonaws.com"
const Digital_Ocean_Spaces = "sfo2.digitaloceanspaces.com"
const BackBlaze_B2 = "s3.us-west-002.backblazeb2.com"


//const prompts = require('prompts')
var readlineSync = require('readline-sync')

var FIRESSTORE_URL_TO_GET_NUMBER = "https://us-central1-helloele.cloudfunctions.net/mvp_add_file_path"
var FIRESSTORE_URL_TO_GET_FILE_DATA = "https://us-central1-helloele.cloudfunctions.net/mvp_get_file_url_by_index"
var FIRESSTORE_URL_TO_CREATE_GROUP = "https://us-central1-helloele.cloudfunctions.net/mvp_create_group"

// node --inspect-brk  ele.js  download 101
//$ functions-framework --target mvp_create_group
var debug = false
if (debug) {
    FIRESSTORE_URL_TO_GET_NUMBER = "http://localhost:8080"
    FIRESSTORE_URL_TO_GET_FILE_DATA = "http://localhost:8080"
    FIRESSTORE_URL_TO_CREATE_GROUP = "http://localhost:8080"
}

// --------------
class Upload extends BaseCommand {
    constructor(args, options) {
        super(args, options);
    }
    action() {

        let epoch_time = (new Date()) / 1000;//|0;
        let local_file_path = utils.check_file_limits(this.getArgsValue(CLI_KEY_FILE_NAME))
        if (local_file_path) {
            const bucket_name = utils.get_config_value(BUCKET_NAME)
            const group_name = utils.get_config_value(GROUP_NAME)
            const group_id = utils.get_config_value(GROUP_ID)
            const public_shared_folder = utils.get_config_value(PUBLIC_SHARED_FOLDER)
            const s3_server_endpoint = utils.get_config_value(S3_SERVER_ENDPOINT)

            let s3_file_obj_name = group_name + "/" + epoch_time + "/" + local_file_path
            let s3_full_public_path = null;
            const DOT = ".";
            const PUBLIC_FILE_PERMISSION = 'public-read'
            let is_public = null;
            if (this.options.public && public_shared_folder) {
                s3_file_obj_name = public_shared_folder + "/" + s3_file_obj_name;
                s3_full_public_path = HTTPS + bucket_name + DOT + s3_server_endpoint + "/" + s3_file_obj_name;
                is_public = PUBLIC_FILE_PERMISSION;
            }
            //console.log(bucket_name, s3_file_obj_name);
            //https://helloele.s3.amazonaws.com/public/testing_public.txt
            //s3.amazonaws.com/public/testing_public.txt


            s3utils.upload_to_s3(local_file_path, bucket_name, s3_file_obj_name, is_public, (data) => {
                //#s3_url = ""#generate_s3_object_url(bucket_name, group_name, s3_file_obj_name)
                this.store_file_path_in_firestore(bucket_name, group_id, group_name, s3_file_obj_name, s3_full_public_path)
            });
        }
    }
    store_file_path_in_firestore(bucket_name, group_id, group_name, s3_file_obj_name, s3_full_public_path) {
        let upload_file_data = {
            "bucket_name": bucket_name,
            "group_id": group_id,
            "group_name": group_name,
            "s3_url": s3_file_obj_name
        }

        //# ---- upload to firestore and get number
        //let res = requests.post(FIRESSTORE_URL_TO_GET_NUMBER, json = upload_file_data)

        /*superagent.post(FIRESSTORE_URL_TO_GET_NUMBER)
            .send(upload_file_data)
            .then( res => {
                //console.log("res.status", res.status, res.headers, " -- ", res.body);
                //console.log( " \n\n   File Number:  ", res.body['file_index'], " \n\n ")
                console.log( " \n\n   Ele Number:  ", res.text, " \n\n ")
            });*/
        axios.post(FIRESSTORE_URL_TO_GET_NUMBER, upload_file_data).then((response) => {

            let pub_url = "";
            if (s3_full_public_path) {
                pub_url = " \n\n " + s3_full_public_path;
            }

            console.log(" \n ");
            //console.log( chalk.underline("file number: ")+ chalk.blue(response.data[FILE_INDEX_FROM_SERVER]));
            console.log("Success!   file number: " + chalk.red(response.data[FILE_INDEX_FROM_SERVER]));
            console.log("\n" + pub_url, "  \n\n  ");
        }, (err) => {
            if (DEBUG) console.log(err); else console.log('Error-96: in fetching file number');
        });
    }
}
//-----------
class Download extends BaseCommand {
    constructor(args) {
        super(args);
    }
    action() {
        const bucket_name = utils.get_config_value(BUCKET_NAME)
        const group_name = utils.get_config_value(GROUP_NAME)
        const group_id = utils.get_config_value(GROUP_ID)

        const file_index = this.getArgsValue(CLI_USER_ENTERED_FILE_NUMBER);
        const local_group_data = { [BUCKET_NAME]: bucket_name, [GROUP_ID]: group_id, [GROUP_NAME]: group_name, [FILE_INDEX_FROM_SERVER]: file_index }

        axios.post(FIRESSTORE_URL_TO_GET_FILE_DATA, local_group_data).then((response) => {
            let file_data_from_db = response.data;
            if (file_data_from_db["delete_status"] == true) {
                console.log("\n File number : " + file_index + " is deleted \n")
            }
            else {

                let s3_file_obj_name = file_data_from_db["s3_url"]
                //console.log("------->", s3_file_obj_name);
                let local_file_path = utils.retrive_file_name_only(s3_file_obj_name) //+ "--downloaded.txt"
                const bucket_name = utils.get_config_value(BUCKET_NAME)
                //let s3_client = get_boto_s3_client()    
                //s3_client.download_file(bucket_name, s3_file_obj_name, local_file_path)
                s3utils.download_file_from_s3(bucket_name, s3_file_obj_name, local_file_path)
            }
        }, (err) => {
            if (DEBUG) console.log(err); else console.log('Error-124: in downloading file');
        });
    }
}

//-------------
class JoinGroup extends BaseCommand {
    constructor(args) {
        super(args)
    }
    action() {
        var group_config_name = this.args['groupConfigFile']
        utils.copy_group_config_to_dot_ele_dir(group_config_name)
    }
}
// ------------
class CreateGroup extends BaseCommand {


    constructor(args, options) {
        super(args, options);
    }
    ask_credentials() {
        let s3_storage_type;
        let s3_storage_service = readlineSync.question(' \n Choose your storage service provider \n [1] AWS Amazon Storage Bucket \n [2] Digital Ocean Spaces \n [3] BackBlaze B2  \n');
        let s3_access_key = readlineSync.question(' \n Please enter s3 access key: ');
        let s3_secret_access_key = readlineSync.question(' \n Please enter s3 secret access key: ');
        let s3_bucket_name = readlineSync.question(' \n Please enter s3 bucket name: ');
        if (s3_storage_service == 1) {
            s3_storage_type = AWS_Amazon_Storage_Bucket;
        } else if (s3_storage_service == 1) {
            s3_storage_type = Digital_Ocean_Spaces;
        } else {
            s3_storage_type = BackBlaze_B2;
        }
        let max_file_size = readlineSync.question(' \n Do you want to limit the maximum size for user to upload(MB)?: ');
        let file_data = "[" + CONSTANTS.DEFAULT + "]" + "\n" + CONSTANTS.ACCESS_KEY + "=" + s3_access_key + "\n" + CONSTANTS.SECRET_ACCESS_KEY + "=" + s3_secret_access_key + "\n" + CONSTANTS.BUCKET_NAME + "=" + s3_bucket_name + "\n" + CONSTANTS.S3_SERVER_ENDPOINT + "=" + s3_storage_type + "\n" + CONSTANTS.MAX_FILE_SIZE + "=" + max_file_size + "\n" + CONSTANTS.PUBLIC_SHARED_FOLDER + "=public" + "\n";
        fs.writeFileSync(CONSTANTS.CONFIG_FILE, file_data, CONSTANTS.UTF_8);
        return CONSTANTS.CONFIG_FILE;

    }
    ask_group_name() {
        var groupName = readlineSync.question(' \n Please enter group name: ');
        return groupName;
    }

    action() {

        // if(this.options.credentials){
        //let new_group_name = this.args['newGroupName']
        //let group_config_file_name = this.args[CLI_GROUP_CONFIG_FILE]
        let group_config_file_name = this.ask_credentials()
        // let group_config_file_name = (this.options.credentials) ? this.options.credentials : null;

        let new_group_name = this.ask_group_name(); //this.args['newGroupName']
        let user_given_config = ini.parse(fs.readFileSync(group_config_file_name, CONSTANTS.UTF_8))
        let user_given_bucket_name = user_given_config[CONSTANTS.DEFAULT][BUCKET_NAME];
        console.log("163", user_given_config, "  buck--", user_given_bucket_name)
        this.call_server_to_create_group(user_given_config, new_group_name, user_given_bucket_name)
        /*} else {
            console.log("Currently ele is in Beta. ");
            console.log("ele create-group creates a group using the credentials file");
        }*/
    }
    call_server_to_create_group(user_given_config, new_group_name, user_given_bucket_name) {
        //let new_group_id = 'DIIncKRLbm3iwgxa7cNY';
        let local_group_data = {
            [BUCKET_NAME]: user_given_bucket_name,
            [GROUP_NAME]: new_group_name
        }
        console.log("201", local_group_data);
        axios.post(FIRESSTORE_URL_TO_CREATE_GROUP, local_group_data).then((response) => {

            let new_group_id = response.data[GROUP_ID]
            console.log(response.data);
            if (response.data[CONSTANTS.STATUS] == CONSTANTS.FAILURE) {
                console.log("Unable to create new group", response.data);
            } else {
                let new_group_file_name = utils.append_group_name_id(user_given_config, new_group_name, new_group_id)
                utils.copy_group_config_to_dot_ele_dir(new_group_file_name)
            }
        }, (err) => {
            if (DEBUG) console.log(err); else console.log('Error-213: in creating group');
        });
    }
}
//--------------
module.exports = {
    Upload,
    Download,
    CreateGroup,
    JoinGroup
};
// --------------
/*exports.upload = function(){
    let up =  new Upload();
    up.action();
}
exports.download = function(){
    console.log("from d");
}
Can be imported in other js files as
const actions = require('./actions');
actions.download(args);
*/

